// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from smacc2_msgs:msg/SmaccStateMachine.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "smacc2_msgs/msg/detail/smacc_state_machine__functions.h"
#include "smacc2_msgs/msg/detail/smacc_state_machine__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace smacc2_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void SmaccStateMachine_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) smacc2_msgs::msg::SmaccStateMachine(_init);
}

void SmaccStateMachine_fini_function(void * message_memory)
{
  auto typed_message = static_cast<smacc2_msgs::msg::SmaccStateMachine *>(message_memory);
  typed_message->~SmaccStateMachine();
}

size_t size_function__SmaccStateMachine__states(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<smacc2_msgs::msg::SmaccState> *>(untyped_member);
  return member->size();
}

const void * get_const_function__SmaccStateMachine__states(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<smacc2_msgs::msg::SmaccState> *>(untyped_member);
  return &member[index];
}

void * get_function__SmaccStateMachine__states(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<smacc2_msgs::msg::SmaccState> *>(untyped_member);
  return &member[index];
}

void fetch_function__SmaccStateMachine__states(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const smacc2_msgs::msg::SmaccState *>(
    get_const_function__SmaccStateMachine__states(untyped_member, index));
  auto & value = *reinterpret_cast<smacc2_msgs::msg::SmaccState *>(untyped_value);
  value = item;
}

void assign_function__SmaccStateMachine__states(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<smacc2_msgs::msg::SmaccState *>(
    get_function__SmaccStateMachine__states(untyped_member, index));
  const auto & value = *reinterpret_cast<const smacc2_msgs::msg::SmaccState *>(untyped_value);
  item = value;
}

void resize_function__SmaccStateMachine__states(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<smacc2_msgs::msg::SmaccState> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SmaccStateMachine_message_member_array[1] = {
  {
    "states",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<smacc2_msgs::msg::SmaccState>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(smacc2_msgs::msg::SmaccStateMachine, states),  // bytes offset in struct
    nullptr,  // default value
    size_function__SmaccStateMachine__states,  // size() function pointer
    get_const_function__SmaccStateMachine__states,  // get_const(index) function pointer
    get_function__SmaccStateMachine__states,  // get(index) function pointer
    fetch_function__SmaccStateMachine__states,  // fetch(index, &value) function pointer
    assign_function__SmaccStateMachine__states,  // assign(index, value) function pointer
    resize_function__SmaccStateMachine__states  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SmaccStateMachine_message_members = {
  "smacc2_msgs::msg",  // message namespace
  "SmaccStateMachine",  // message name
  1,  // number of fields
  sizeof(smacc2_msgs::msg::SmaccStateMachine),
  SmaccStateMachine_message_member_array,  // message members
  SmaccStateMachine_init_function,  // function to initialize message memory (memory has to be allocated)
  SmaccStateMachine_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SmaccStateMachine_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SmaccStateMachine_message_members,
  get_message_typesupport_handle_function,
  &smacc2_msgs__msg__SmaccStateMachine__get_type_hash,
  &smacc2_msgs__msg__SmaccStateMachine__get_type_description,
  &smacc2_msgs__msg__SmaccStateMachine__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace smacc2_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<smacc2_msgs::msg::SmaccStateMachine>()
{
  return &::smacc2_msgs::msg::rosidl_typesupport_introspection_cpp::SmaccStateMachine_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, smacc2_msgs, msg, SmaccStateMachine)() {
  return &::smacc2_msgs::msg::rosidl_typesupport_introspection_cpp::SmaccStateMachine_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
